<?php


namespace FiloBlu\Pos\Controller\Posmode;

use Magento\Framework\Stdlib\Cookie\CookieMetadataFactory;
use Magento\Framework\Stdlib\CookieManagerInterface;

class Enable extends \Magento\Framework\App\Action\Action
{

    const COOKIE_NAME = 'filoblu_pos_mode';
    const COOKIE_DURATION = 86400 * 30; // 30 days

    /**
     * @var CookieManagerInterface
     */
    protected $cookieManager;

    /**
     * @var CookieMetadataFactory
     */
    protected $cookieMetadataFactory;

    /**
     * Enable constructor.
     * @param CookieManagerInterface $cookieManager
     * @param CookieMetadataFactory $cookieMetadataFactory
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        CookieManagerInterface $cookieManager,
        CookieMetadataFactory $cookieMetadataFactory
    ) {
        $this->cookieManager = $cookieManager;
        $this->cookieMetadataFactory = $cookieMetadataFactory;
        parent::__construct($context);
    }

    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {

        $enableRequest = $this->getRequest()->getParam('enable');

        if ($enableRequest == 1) {
            $cookieValue = 1;
        } else {
            $cookieValue = 0;
        }

        $metadata = $this->cookieMetadataFactory
            ->createPublicCookieMetadata()
            ->setDuration(self::COOKIE_DURATION)
            ->setPath('/');
        $this->cookieManager
            ->setPublicCookie(self::COOKIE_NAME, $cookieValue, $metadata);
        //$this->messageManager->addSuccessMessage('POS mode enabled');
        return $this->_redirect('/');
    }
}